#include <string>

#include "about_box.hpp"
#include "global.hpp"
#include "resource.hpp"


BOOL CALLBACK about_dlg_proc(HWND hwnd, UINT msg, WPARAM wparam,
    LPARAM lparam)
{
    switch(msg){

        case WM_INITDIALOG:
        {
            std::string buffer;
            HGLOBAL hres = LoadResource (global::hinstance,
                FindResource (global::hinstance, "IDT_GPL", "TEXT"));

            char* p=(char*)LockResource(hres);
            buffer.assign(p, strchr(p, '%'));
            FreeResource(hres);
            SetWindowText(GetDlgItem(hwnd, IDC_ABOUT_EDIT), buffer.c_str());
            SendDlgItemMessage(hwnd, IDC_ABOUT_EDIT, WM_SETFONT,
                (WPARAM)GetStockObject(ANSI_FIXED_FONT), TRUE);
            return true;
        }
        case WM_CTLCOLORSTATIC:
        {
            if(lparam==(LPARAM)GetDlgItem(hwnd, IDC_ABOUT_EDIT)){
                return (BOOL)GetStockObject(WHITE_BRUSH);
            }else return false;
        }

        case WM_COMMAND:
            switch(LOWORD(wparam)){
                case IDOK:
                    EndDialog(hwnd, 0);
                    return true;
            }
            return true;

        case WM_CLOSE:
            EndDialog(hwnd,0);
            return true;

    }

    return false;
}

namespace about_box{

void show(HWND hwnd)
{
    DialogBox(global::hinstance, "IDD_ABOUT", hwnd, about_dlg_proc);
}

}
